/*
Released under GPL, written by caolan@csn.ul.ie.

Copyright (C) 1998,1999,2000 
	Caolan McNamara

Real Life: Caolan McNamara           *  Email: caolan@csn.ul.ie
URL: http://www.csn.ul.ie/~caolan    *  Sig: an oblique strategy
How would you have done it?
*/
#ifndef IVT_MAGIC
#define IVT_MAGIC
int wvInflatemszp(U8 *srcbuffer, U8 *destbuffer);

typedef struct _MSZP
{
	U8 id[4]; /*mszp*/
	U32 uncomprLen1;
	U32 unknown;
	U16 uncomprLen;
	U16 comprLen;
  	U8 *compr;
}MSZP;
void wvGetMSZP(MSZP *item,FILE *fd);
void wvInitMSZP(MSZP *item);

#define IVTINDEX (';' + ')'*0x100)  /* at least MS programs are humorous */
#define IVTHEADER 0x01045f3f
#define IVTMAGIC 0x707a736d
#define IVIMAGIC 0x707a736e
#define SETMAGIC 0x6765725b

#ifndef MIN
#define MIN(X,Y) (((X)<(Y))?(X):(Y))
#endif

typedef struct _ivthdr {
   U32 Magic;
   U32 DirectoryStart;
   U32 uk1;
   U32 uk2;
   U32 uk3;
   U32 filesz;
   U32 uk4;
   U32 uk5;
   U32 uk6;
   U32 uk7;
} ivthdr;
void wvGetivthdr(FILE *fd,ivthdr *item);

typedef struct _globalivtidx {
   U16 magic;
   U16 flags;
   U32 uk1[10];
   U32 fullentries;
} globalivtidx;

typedef struct _ivtidx {
   U16 nextoffset;
   U16 entries;
   U32 uk2[2];
} ivtidx;
void wvGetglobalivtidx(FILE *fd,globalivtidx *item);
int wvGetivtidx(FILE *fd,ivtidx *item);


typedef struct _entry {
   S8 name[0x200];
   S32 offset;
   U32 counter;
   S32 length;
   struct _entry *next;
} mszpentry;

typedef struct _mszpfile {
    U32 magic;
    U8 uk1[8];
    U16 clength; /* content length */
    U16 tlength; /* total length */
} mszpfile;

typedef struct _ckhdr {
    U8 magic[2];
    U8 key;
    U16 length;
    U16 invlength;
} ckhdr;

typedef struct _gifhdr {
    U8 magic[5];
} gifhdr;

int wvDumpFile(FILE *mszp,mszpentry *t);
int wvOutputHtml(FILE *mszp,mszpentry *t);
int wvGetmszpentry(FILE *ivt,mszpentry *entry);
void wvGetmszpentryChain(FILE *ivt,mszpentry **chain,globalivtidx *index);
void wvReleasemszpentryChain(mszpentry **chain);
#endif
